## votca-tools 1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(votca-tools)

set(PROJECT_VERSION "1.5")
string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
if (NOT ${SOVERSION} MATCHES "[1-9]+")
  message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
endif (NOT ${SOVERSION} MATCHES "[1-9]+")

# Cmake modules/macros are in a subdirectory to keep this file cleaner
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
  #release comes with -O3 by default
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)

enable_language(CXX)



######################################################################
# compiler tests
# these need ot be done early (before further tests).
#####################################################################

include(CheckCXXCompilerFlag)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" AND CMAKE_VERSION VERSION_LESS "3.6.0")
  message(FATAL_ERROR "Using the intel compiler requires cmake 3.6 or higher")
endif()


########################################################################
# User input options                                                   #
########################################################################
option(BUILD_SHARED_LIBS "Build shared libs" ON)
include(GNUInstallDirs)

option(ENABLE_TESTING "Build and enable testing stuff" OFF)
if(ENABLE_TESTING)
  enable_testing()
endif(ENABLE_TESTING)

#this has to be the first include directive
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
#for votca_config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)

########################################################################
#Find external packages
########################################################################
if(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  find_package(Git)
endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)

find_package(Threads REQUIRED)
set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})

find_package(Boost 1.57.0 REQUIRED COMPONENTS program_options filesystem system )
include_directories(${Boost_INCLUDE_DIRS})
set (BOOST_CFLAGS_PKG "-I${Boost_INCLUDE_DIRS}")
set(BOOST_LIBS_PKG "-L${Boost_LIBRARY_DIRS}")
foreach(_blib ${Boost_LIBRARIES})
  string(REGEX REPLACE ".*/lib([^/]*)\\.[^.]*$" "-l\\1" _blib ${_blib})
  set(BOOST_LIBS_PKG "${BOOST_LIBS_PKG} ${_blib}")
endforeach(_blib)

option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" ON)
#define this target here, so that individual man pages can append to it.
add_custom_target(manpages ALL)

########################################################################
# Checks what linear algebra packages are installed                    #
########################################################################

find_package(MKL)
if (MKL_FOUND)
  include_directories(${MKL_INCLUDE_DIRS})
  set (MKL TRUE )
else()
  set(MKL_LIBRARIES)
endif()

find_package(Eigen3 3.3.0 REQUIRED)
include_directories(${EIGEN3_INCLUDE_DIR})
set(EIGEN3_PKG eigen3)

option(WITH_FFTW "Use FFTW3, disabling leads to reduced functionality!" ON)
if (WITH_FFTW)
  find_package(FFTW3)
  if(NOT FFTW3_FOUND)
    message(FATAL_ERROR "FFTW3 not found,  make sure you have also installed the fftw3 and it's dev package (it can be disable with -DWITH_FFTW=OFF)")
  endif(NOT FFTW3_FOUND)
  include_directories(${FFTW3_INCLUDE_DIRS})
  set(FFTW3_PKG "fftw3")
else(WITH_FFTW)
  #used in votca_config.h
  set(NOFFTW TRUE)
  set(FFTW3_PKG)
endif(WITH_FFTW)

########################################################################
# Basic system tests (standard libraries, headers, functions, types)   #
########################################################################
include(CheckIncludeFile)
foreach(HEADER assert.h math.h stdio.h stdlib.h string.h)
  check_include_file(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

include(CheckIncludeFileCXX)
foreach(HEADER cmath fstream functional iostream limits list map ostream sstream stack stdexcept string vector)
  check_include_file_cxx(${HEADER} FOUND_${HEADER})
  if(NOT FOUND_${HEADER})
    message(FATAL_ERROR "Could not find needed header - ${HEADER}")
  endif(NOT FOUND_${HEADER})
endforeach(HEADER)

set(MATH_LIBRARIES "m" CACHE STRING "math library")
mark_as_advanced( MATH_LIBRARIES )
include(CheckLibraryExists)
foreach(FUNC sqrt)
  check_library_exists(${MATH_LIBRARIES} ${FUNC} "" FOUND_${FUNC}_${MATH_LIBRARIES})
  if(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
    message(FATAL_ERROR "Could not find needed math function - ${FUNC}")
  endif(NOT FOUND_${FUNC}_${MATH_LIBRARIES})
endforeach(FUNC)

######################################
# Include the following subdirectory #
######################################
add_subdirectory(src)
add_subdirectory(include/votca/tools)
add_subdirectory(scripts)
add_subdirectory(share/man)
add_subdirectory(share/doc)

configure_file(${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  include(FeatureSummary)
  feature_summary(INCLUDE_QUIET_PACKAGES WHAT ALL)
endif (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)

=== scripts/CMakeLists.txt ===
option(WITH_RC_FILES "Install votca rc files, no need when installing under /usr" ON)
if (WITH_RC_FILES)
  if(APPLE)
    set(LD_LIBRARY_PATH "DYLD_LIBRARY_PATH")
  else(APPLE)
    include(CheckCSourceCompiles)
    check_c_source_compiles(
      "int main(void) {
      #ifndef _AIX
      #error
      #endif
      return 0;
      }" HAVE_AIX)
    if(HAVE_AIX)
      set(LD_LIBRARY_PATH "LIBPATH")
    else(HAVE_AIX)
      set(LD_LIBRARY_PATH "LD_LIBRARY_PATH")
    endif(HAVE_AIX)
  endif(APPLE)
  configure_file(VOTCARC.csh.in ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.csh @ONLY)
  configure_file(VOTCARC.bash.in ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.bash @ONLY)
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.csh
    ${CMAKE_CURRENT_BINARY_DIR}/VOTCARC.bash DESTINATION ${CMAKE_INSTALL_BINDIR})
endif (WITH_RC_FILES)

foreach(SCRIPT votca_compare)
  configure_file(${SCRIPT}.in ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}.out @ONLY)
  add_custom_target(${SCRIPT}_build ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT})
  add_custom_command(OUTPUT ${SCRIPT} COMMAND ${CMAKE_COMMAND}
    -DINPUT="${SCRIPT}.out" -DOUTPUT="${SCRIPT}"
    -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
    -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${CMAKE_MODULE_PATH}/gitscript.cmake)
  if(ENABLE_TESTING)
    add_custom_command(TARGET ${SCRIPT}_build POST_BUILD COMMAND chmod +x ${SCRIPT})
  endif(ENABLE_TESTING)
  set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
  install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
endforeach(SCRIPT)

=== share/man/CMakeLists.txt ===
if (BUILD_MANPAGES)
  add_custom_target(votca_tools_manpages DEPENDS votca-tools.man)
  add_dependencies(manpages votca_tools_manpages)
  install(FILES votca-tools.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man7 RENAME votca-tools.7)
endif (BUILD_MANPAGES)

=== src/libtools/CMakeLists.txt ===
find_package(EXPAT)
if(NOT EXPAT_FOUND)
  message(FATAL_ERROR "EXPAT not found,  make sure you have also installed the expat and it's dev package")
endif(NOT EXPAT_FOUND)
include_directories(${EXPAT_INCLUDE_DIR})
set (EXPAT_CFLAGS_PKG "-I${EXPAT_INCLUDE_DIRS}")
string(REGEX REPLACE "^(.*)/lib([^/]*)\\.[^.]*$" "-L\\1 -l\\2" EXPAT_LIBS_PKG ${EXPAT_LIBRARY})

file(GLOB VOTCA_SOURCES *.cc)
file(GLOB NOT_VOTCA_SOURCES version_nb.cc)
file(GLOB_RECURSE VOTCA_SQL_SOURCES database.cc statement.cc)
list(REMOVE_ITEM VOTCA_SOURCES ${NOT_VOTCA_SOURCES} ${VOTCA_SQL_SOURCES})

option(WITH_SQLITE3 "Use SQLite3, at this point only needed for charge transport parts!" ON)
if (WITH_SQLITE3)
  find_package(SQLITE3)
  if(NOT SQLITE3_FOUND)
    message(FATAL_ERROR "SQLITE3 not found,  make sure you have also installed the sqlite3 and it's dev package, at this point sqlite3 is only needed for charge transport parts of VOTCA, so you can just switch it off using -DWITH_SQLITE3=OFF in case you do not need it.")
  endif(NOT SQLITE3_FOUND)
  include_directories(${SQLITE3_INCLUDE_DIRS})
  set(SQLITE3_PKG "sqlite3")
else(WITH_SQLITE3)
  set(SQLITE3_PKG)
  set(VOTCA_SQL_SOURCES)
endif(WITH_SQLITE3)


#for gitversion.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_custom_target(gitversion COMMAND ${CMAKE_COMMAND}
  -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -DMERCURIAL_EXECUTABLE="${MERCURIAL_EXECUTABLE}"
  -P ${CMAKE_MODULE_PATH}/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

add_library(votca_tools ${VOTCA_SOURCES} ${VOTCA_SQL_SOURCES} ${VOTCA_LINALG_SOURCES})
add_dependencies(votca_tools gitversion)

set_target_properties(votca_tools PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_tools ${Boost_LIBRARIES} ${MKL_LIBRARIES} ${SQLITE3_LIBRARIES}
  ${FFTW3_LIBRARIES} ${EXPAT_LIBRARIES} ${THREAD_LIBRARIES} ${MATH_LIBRARIES})
install(TARGETS votca_tools LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

configure_file(libvotca_tools.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libvotca_tools.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/tests/CMakeLists.txt ===
find_package(Boost 1.57.0 REQUIRED COMPONENTS unit_test_framework)

# Each test listed in Alphabetical order
foreach(PROG
    test_cubicspline
    test_datacollection
    test_edge_base
    test_edgecontainer
    test_elements
    test_floatingpointcomparison
    test_graph_base
    test_graph_bf_visitor
    test_graphalgorithm
    test_graphdistvisitor
    test_graphnode
    test_graphvisitor
    test_histogramnew
    test_identity
    test_linalg
    test_matrix
    test_name
    test_table
    test_thread
    test_typeconverter
    test_vec
    test_property)

  file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
  add_executable(unit_${PROG} ${${PROG}_SOURCES})
  target_link_libraries(unit_${PROG} votca_tools ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
  target_compile_definitions(unit_${PROG} PRIVATE BOOST_TEST_DYN_LINK)
  add_test(unit_${PROG} unit_${PROG})
  # run tests for tools (for coverage) as well
  set_tests_properties(unit_${PROG} PROPERTIES LABELS "tools;votca")

endforeach(PROG)

=== src/tools/CMakeLists.txt ===
foreach(PROG votca_property)
  file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
  add_executable(${PROG} ${${PROG}_SOURCES})
  target_link_libraries(${PROG} votca_tools)
  #not realy useful, re-enable whenever it is ready to replace csg_property
  install(TARGETS ${PROG} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  if (BUILD_MANPAGES)
     add_custom_command(OUTPUT ${PROG}.man
       COMMAND ${CMAKE_CURRENT_BINARY_DIR}/${PROG} --man > ${PROG}.man
       COMMENT "Building ${PROG} manpage"
       DEPENDS ${PROG})
     add_custom_target(${PROG}_manpage DEPENDS ${PROG}.man)
     add_dependencies(manpages ${PROG}_manpage)
     install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROG}.man DESTINATION ${CMAKE_INSTALL_MANDIR}/man1 RENAME ${PROG}.1)
  endif (BUILD_MANPAGES)

  if(ENABLE_TESTING)
    add_test(${PROG}Help ${PROG} --help)
    set_tests_properties(${PROG}Help PROPERTIES LABELS "tools;votca")
  endif(ENABLE_TESTING)
endforeach(PROG)

=== include/votca/tools/CMakeLists.txt ===
configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)

file(GLOB_RECURSE VOTCA_HEADERS *.h ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h )

if (NOT WITH_SQLITE3)
  file(GLOB_RECURSE NOT_VOTCA_HEADERS database.h statement.h)
  list(REMOVE_ITEM VOTCA_HEADERS ${NOT_VOTCA_HEADERS})
endif(NOT WITH_SQLITE3)

install(FILES ${VOTCA_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/votca/tools)

=== debian/changelog ===
votca-tools (1.5-2) unstable; urgency=high

  * libvotca-tools-dev: Additionally set Breaks/Replaces on libvotca-tools3.
    (Closes: #921665)

 -- Nicholas Breen <nbreen@debian.org>  Thu, 07 Feb 2019 18:57:53 -0800

votca-tools (1.5-1) unstable; urgency=medium

  * New upstream release.
    - Rename libvotca-tools4 to libvotca-tools5.
  * Add myself to uploaders.
  * Enable new test suite.
  * Add Build-Depends on libeigen3-dev and, for the tests,
    libboost-test-dev.
  * Minor housekeeping: update copyright years, update Standards-Version,
    set Rules-Requires-Root: no.
  * Move man pages to -dev package, allowing coinstallability of future
    library versions.

 -- Nicholas Breen <nbreen@debian.org>  Fri, 01 Feb 2019 18:06:30 -0800

=== debian/control ===
Source: votca-tools
Section: libs
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Christoph Junghans <junghans@votca.org>,
           Michael Banck <mbanck@debian.org>,
           Nicholas Breen <nbreen@debian.org>
Build-Depends: cmake,
               debhelper (>= 9.0.0),
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-test-dev,
               libeigen3-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgsl-dev,
               libsqlite3-dev,
               pkg-config,
               txt2tags
Rules-Requires-Root: no
Standards-Version: 4.3.0
Homepage: http://www.votca.org
Vcs-Browser: https://salsa.debian.org/debichem-team/votca-tools
Vcs-Git: https://salsa.debian.org/debichem-team/votca-tools.git

Package: libvotca-tools-dev
Section: libdevel
Architecture: any
Depends: libvotca-tools5 (= ${binary:Version}), ${misc:Depends}
Breaks: libvotca-tools4 (<< 1.4.1-3~), libvotca-tools3 (<< 1.3.0-3~)
Replaces: libvotca-tools4, libvotca-tools3
Description: VOTCA's tools library, development kit
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.
 .
 This package contains header files and pkg-config files.

Package: libvotca-tools5
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: libvotca-tools2 (<< 1.3), libvotca-tools3
Replaces: libvotca-tools2 (<< 1.3), libvotca-tools3
Description: VOTCA's tools library
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_configure:
	dh_auto_configure -- -DLIB=lib/$(DEB_HOST_MULTIARCH) -DENABLE_TESTING=On

%:
	dh $@

=== debian/watch ===
version=3
https://github.com/votca/tools/releases .*/archive/v([\d.]+)\.tar\.(?:bz2|gz)

## votca-tools 1.6~rc1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.10)
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.5")
+set(PROJECT_VERSION "1.6_rc1")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
@@ -26,12 +26,9 @@
 #####################################################################
 
 include(CheckCXXCompilerFlag)
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF) #...without compiler extensions like gnu++11
-if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" AND CMAKE_VERSION VERSION_LESS "3.6.0")
-  message(FATAL_ERROR "Using the intel compiler requires cmake 3.6 or higher")
-endif()
 
 
 ########################################################################
@@ -43,12 +40,10 @@
 option(ENABLE_TESTING "Build and enable testing stuff" OFF)
 if(ENABLE_TESTING)
   enable_testing()
+  include(FindPackageHandleStandardArgs) 
+  find_program(VALGRIND_EXECUTABLE "valgrind")
+  find_package_handle_standard_args(VALGRIND REQUIRED_VARS VALGRIND_EXECUTABLE)
 endif(ENABLE_TESTING)
-
-#this has to be the first include directive
-include_directories(${CMAKE_CURRENT_SOURCE_DIR}/include)
-#for votca_config.h
-include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
 
 ########################################################################
 #Find external packages
@@ -58,16 +53,8 @@
 endif(IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/.git)
 
 find_package(Threads REQUIRED)
-set(THREAD_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
 
-find_package(Boost 1.57.0 REQUIRED COMPONENTS program_options filesystem system )
-include_directories(${Boost_INCLUDE_DIRS})
-set (BOOST_CFLAGS_PKG "-I${Boost_INCLUDE_DIRS}")
-set(BOOST_LIBS_PKG "-L${Boost_LIBRARY_DIRS}")
-foreach(_blib ${Boost_LIBRARIES})
-  string(REGEX REPLACE ".*/lib([^/]*)\\.[^.]*$" "-l\\1" _blib ${_blib})
-  set(BOOST_LIBS_PKG "${BOOST_LIBS_PKG} ${_blib}")
-endforeach(_blib)
+find_package(Boost 1.53.0 REQUIRED COMPONENTS program_options filesystem system )
 
 option(BUILD_MANPAGES "Build manpages (might lead to problem on system without rpath" ON)
 #define this target here, so that individual man pages can append to it.
@@ -76,32 +63,13 @@
 ########################################################################
 # Checks what linear algebra packages are installed                    #
 ########################################################################
+set(MKL_THREAD_LAYER "Intel OpenMP" CACHE STRING "The thread layer to choose for MKL")
+find_package(MKL)
 
-find_package(MKL)
-if (MKL_FOUND)
-  include_directories(${MKL_INCLUDE_DIRS})
-  set (MKL TRUE )
-else()
-  set(MKL_LIBRARIES)
-endif()
+find_package(Eigen3 3.3.0 NO_MODULE REQUIRED)
+message(STATUS "Found Eigen3: ${Eigen3_DIR}")
 
-find_package(Eigen3 3.3.0 REQUIRED)
-include_directories(${EIGEN3_INCLUDE_DIR})
-set(EIGEN3_PKG eigen3)
-
-option(WITH_FFTW "Use FFTW3, disabling leads to reduced functionality!" ON)
-if (WITH_FFTW)
-  find_package(FFTW3)
-  if(NOT FFTW3_FOUND)
-    message(FATAL_ERROR "FFTW3 not found,  make sure you have also installed the fftw3 and it's dev package (it can be disable with -DWITH_FFTW=OFF)")
-  endif(NOT FFTW3_FOUND)
-  include_directories(${FFTW3_INCLUDE_DIRS})
-  set(FFTW3_PKG "fftw3")
-else(WITH_FFTW)
-  #used in votca_config.h
-  set(NOFFTW TRUE)
-  set(FFTW3_PKG)
-endif(WITH_FFTW)
+find_package(FFTW3)
 
 ########################################################################
 # Basic system tests (standard libraries, headers, functions, types)   #

=== scripts/CMakeLists.txt ===
--- 
+++ 
@@ -36,3 +36,6 @@
   set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
   install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
 endforeach(SCRIPT)
+
+add_executable(VOTCA::votca_compare IMPORTED GLOBAL)
+set_property(TARGET VOTCA::votca_compare PROPERTY IMPORTED_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/votca_compare")

=== src/libtools/CMakeLists.txt ===
find_package(EXPAT REQUIRED)

file(GLOB VOTCA_SOURCES *.cc)

add_library(votca_tools ${VOTCA_SOURCES} ${VOTCA_LINALG_SOURCES})

#CMAKE_CURRENT_BINARY_DIR for gitversion.h
#PROJECT_BINARY_DIR/include for votca_config.h
target_include_directories(votca_tools PRIVATE ${CMAKE_CURRENT_BINARY_DIR}
  PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

add_custom_target(gitversion COMMAND ${CMAKE_COMMAND}
  -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
  -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
  -P ${CMAKE_MODULE_PATH}/gitversion.cmake)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES gitversion.h)

add_dependencies(votca_tools gitversion)

set_target_properties(votca_tools PROPERTIES SOVERSION ${SOVERSION})
target_link_libraries(votca_tools PUBLIC Boost::boost Boost::program_options Eigen3::Eigen PRIVATE
	Boost::filesystem Boost::system EXPAT::EXPAT Threads::Threads ${MATH_LIBRARIES})
if(TARGET MKL::MKL)
  target_link_libraries(votca_tools PUBLIC MKL::MKL)
  foreach(_PROP IMPORTED_LOCATION INTERFACE_LINK_LIBRARIES INTERFACE_INCLUDE_DIRECTORIES IMPORTED_NO_SONAME)
    get_target_property(MKL_${_PROP} MKL::MKL ${_PROP})
  endforeach()
  foreach(_TGT Interface ThreadLayer)
    get_target_property(MKL_${_TGT}_IMPORTED_LOCATION MKL::${_TGT} IMPORTED_LOCATION)
  endforeach()
endif()
if(TARGET FFTW3::FFTW3)
  target_link_libraries(votca_tools PRIVATE FFTW3::FFTW3)
endif()
install(TARGETS votca_tools EXPORT VOTCA_TOOLS_Targets
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT VOTCA_TOOLS_Targets FILE VOTCA_TOOLS_Targets.cmake NAMESPACE VOTCA:: DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_TOOLS)

include(CMakePackageConfigHelpers)
write_basic_package_version_file("VOTCA_TOOLSConfigVersion.cmake" VERSION ${PROJECT_VERSION} COMPATIBILITY ExactVersion)
configure_file(VOTCA_TOOLSConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/VOTCA_TOOLSConfig.cmake @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_TOOLSConfig.cmake" "${CMAKE_CURRENT_BINARY_DIR}/VOTCA_TOOLSConfigVersion.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_TOOLS)
add_library(VOTCA::votca_tools ALIAS votca_tools)

=== src/tests/CMakeLists.txt ===
find_package(Boost 1.53.0 REQUIRED COMPONENTS unit_test_framework)

# Each test listed in Alphabetical order
foreach(PROG
    test_constants
    test_correlate
    test_crosscorrelate
    test_cubicspline
    test_datacollection
    test_edge_base
    test_edgecontainer
    test_elements
    test_filesystem
    test_floatingpointcomparison
    test_graphalgorithm
    test_graph_base
    test_graph_bf_visitor
    test_graph_df_visitor
    test_graphdistvisitor
    test_graphnode
    test_graphvisitor
    test_histogramnew
    test_identity
    test_linalg
    test_name
    test_property
    test_reducededge
    test_reducedgraph
    test_structureparameters
    test_table
    test_thread
    test_tokenizer
    test_random
    test_akimaspline
    test_linspline
    test_unitconverter)

  file(GLOB ${PROG}_SOURCES ${PROG}*.cc)
  add_executable(unit_${PROG} ${${PROG}_SOURCES})
  target_link_libraries(unit_${PROG} votca_tools Boost::unit_test_framework)
  target_compile_definitions(unit_${PROG} PRIVATE BOOST_TEST_DYN_LINK)
  add_test(unit_${PROG} unit_${PROG})
  # run tests for tools (for coverage) as well
  set_tests_properties(unit_${PROG} PROPERTIES LABELS "tools;votca;unit")

  if(VALGRIND_FOUND)
    add_test(NAME memory_${PROG} COMMAND "${VALGRIND_EXECUTABLE}" --tool=memcheck --leak-check=yes --show-reachable=yes --num-callers=20 --track-fds=yes --error-exitcode=1 $<TARGET_FILE:unit_${PROG}>)
    set_tests_properties(memory_${PROG} PROPERTIES LABELS "tools;votca;memory")
  endif(VALGRIND_FOUND) 
endforeach(PROG)

=== include/votca/tools/CMakeLists.txt ===
configure_file(votca_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h)

file(GLOB_RECURSE VOTCA_HEADERS *.h ${CMAKE_CURRENT_BINARY_DIR}/votca_config.h )

install(FILES ${VOTCA_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/votca/tools)

=== debian/changelog ===
votca-tools (1.6~rc1-3build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:53:25 +0000

votca-tools (1.6~rc1-3) unstable; urgency=medium

  * Add Breaks/Replaces: libvotca-tools-dev (<< 1.6~rc1-1) to votca-tools
    for a file move.  (Closes: #949774)
  * Remove old Breaks/Replaces from oldstable and before.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 26 Jan 2020 10:22:42 -0800

votca-tools (1.6~rc1-2) unstable; urgency=medium

  * d/patches/smoothing_test.diff: Cherry-pick from upstream commit at
    <https://github.com/votca/tools/issues/195>, to solve test failures
    at table_test/smoothing_test on many architectures.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 23 Jan 2020 18:20:06 -0800

votca-tools (1.6~rc1-1) unstable; urgency=medium

  * New upstream release candidate.
    - Rename libvotca-tools5 to libvotca-tools6.
    - Remove B-D on libsqlite3-dev, no longer needed.
  * Add new 'votca-tools' (binary) package for helper tools.  Add B-D on
    dh-python and python3 for votca_compare script.
  * Update to Standards-Version 4.5.0, no changes required.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 20 Jan 2020 16:53:24 -0800

votca-tools (1.5.1-1) unstable; urgency=medium

  * New upstream release.
  * Update to Standards-Version 4.4.1 and debhelper 12.  No changes
    required.
  * Add dependencies on lib{boost-filesystem, boost-program-options,
    eigen1}-dev to libvotca-tools-dev.

 -- Nicholas Breen <nbreen@debian.org>  Fri, 29 Nov 2019 10:24:02 -0800

=== debian/control ===
Source: votca-tools
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Christoph Junghans <junghans@votca.org>,
           Michael Banck <mbanck@debian.org>,
           Nicholas Breen <nbreen@debian.org>
Build-Depends: cmake,
               debhelper (>= 12),
               dh-python,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-test-dev,
               libeigen3-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgsl-dev,
               pkg-config,
               python3,
               txt2tags
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: http://www.votca.org
Vcs-Browser: https://salsa.debian.org/debichem-team/votca-tools
Vcs-Git: https://salsa.debian.org/debichem-team/votca-tools.git

Package: libvotca-tools-dev
Section: libdevel
Architecture: any
Depends: libboost-filesystem-dev,
         libboost-program-options-dev,
         libexpat1-dev,
         libvotca-tools6 (= ${binary:Version}),
         ${misc:Depends}
Description: VOTCA's tools library, development kit
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.
 .
 This package contains header files and pkg-config files.

Package: libvotca-tools6
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: VOTCA's tools library
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.

Package: votca-tools
Section: science
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Replaces: libvotca-tools-dev (<< 1.6~rc1-1)
Breaks: libvotca-tools-dev (<< 1.6~rc1-1)
Description: VOTCA's tools library, helper binaries
 VOTCA is a software package which focuses on the analysis of molecular
 dynamics data, the development of systematic coarse-graining techniques as
 well as methods used for simulating microscopic charge transport in
 disordered semiconductors.
 .
 VOTCA's tools library provides functions shared between all VOTCA packages.
 .
 This package contains helper binaries and shell RC file fragments.

=== debian/rules ===
--- 
+++ 
@@ -17,4 +17,4 @@
 	dh_auto_configure -- -DLIB=lib/$(DEB_HOST_MULTIARCH) -DENABLE_TESTING=On
 
 %:
-	dh $@ 
+	dh $@  --with python3

## votca-tools 1.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.6_rc1")
+set(PROJECT_VERSION "1.6.2")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")
@@ -17,8 +17,6 @@
 endif(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CXX_FLAGS)
 
 enable_language(CXX)
-
-
 
 ######################################################################
 # compiler tests
@@ -107,7 +105,6 @@
 add_subdirectory(include/votca/tools)
 add_subdirectory(scripts)
 add_subdirectory(share/man)
-add_subdirectory(share/doc)
 
 configure_file(${CMAKE_MODULE_PATH}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
 add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

=== debian/changelog ===
votca-tools (1.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Update to debhelper compat 13.
  * Update d/copyright for 2020.

 -- Nicholas Breen <nbreen@debian.org>  Tue, 25 Aug 2020 21:55:48 -0700

votca-tools (1.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Add debian/salsa-ci.yml, with basic CI tests.
  * Set Multi-Arch: Same on libvotca-tools6 and -tools-dev.

 -- Nicholas Breen <nbreen@debian.org>  Fri, 17 Jul 2020 17:04:31 -0700

votca-tools (1.6-1) unstable; urgency=medium

  * New upstream release.
  * Remove d/patches/smoothing_test.patch, incorporated upstream.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 18 Apr 2020 16:08:12 -0700

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: votca-tools
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Christoph Junghans <junghans@votca.org>,
            Michael Banck <mbanck@debian.org>,
            Nicholas Breen <nbreen@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 13),
                dh-python,
                libboost-filesystem-dev,
                libboost-program-options-dev,
@@ -29,6 +28,7 @@
 Package: libvotca-tools-dev
 Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libboost-filesystem-dev,
          libboost-program-options-dev,
          libexpat1-dev,
@@ -46,6 +46,7 @@
 
 Package: libvotca-tools6
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: VOTCA's tools library
  VOTCA is a software package which focuses on the analysis of molecular

## votca-tools 1.6.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 project(votca-tools)
 
-set(PROJECT_VERSION "1.6.2")
+set(PROJECT_VERSION "1.6.4")
 string(REGEX REPLACE "^[1-9]+\\.([1-9]+).*$" "\\1" SOVERSION "${PROJECT_VERSION}")
 if (NOT ${SOVERSION} MATCHES "[1-9]+")
   message(FATAL_ERROR "Could not determind SOVERSION from ${PROJECT_VERSION}")

=== scripts/CMakeLists.txt ===
--- 
+++ 
@@ -30,9 +30,9 @@
     -DINPUT="${SCRIPT}.out" -DOUTPUT="${SCRIPT}"
     -DGIT_EXECUTABLE="${GIT_EXECUTABLE}"
     -DTOP_SOURCE_DIR="${CMAKE_SOURCE_DIR}" -P ${CMAKE_MODULE_PATH}/gitscript.cmake)
-  if(ENABLE_TESTING)
+  if(ENABLE_TESTING OR ENABLE_REGRESSION_TESTING)
     add_custom_command(TARGET ${SCRIPT}_build POST_BUILD COMMAND chmod +x ${SCRIPT})
-  endif(ENABLE_TESTING)
+  endif(ENABLE_TESTING OR ENABLE_REGRESSION_TESTING)
   set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES ${SCRIPT})
   install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT} DESTINATION ${CMAKE_INSTALL_BINDIR})
 endforeach(SCRIPT)

=== src/CMakeLists.txt ===
add_subdirectory(libtools)
add_subdirectory(tools)
if(ENABLE_TESTING)
  add_subdirectory(tests)
endif()

=== src/libtools/CMakeLists.txt ===
--- 
+++ 
@@ -24,12 +24,7 @@
 	Boost::filesystem Boost::system EXPAT::EXPAT Threads::Threads ${MATH_LIBRARIES})
 if(TARGET MKL::MKL)
   target_link_libraries(votca_tools PUBLIC MKL::MKL)
-  foreach(_PROP IMPORTED_LOCATION INTERFACE_LINK_LIBRARIES INTERFACE_INCLUDE_DIRECTORIES IMPORTED_NO_SONAME)
-    get_target_property(MKL_${_PROP} MKL::MKL ${_PROP})
-  endforeach()
-  foreach(_TGT Interface ThreadLayer)
-    get_target_property(MKL_${_TGT}_IMPORTED_LOCATION MKL::${_TGT} IMPORTED_LOCATION)
-  endforeach()
+  install(FILES "${PROJECT_SOURCE_DIR}/CMakeModules/FindMKL.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VOTCA_TOOLS)
 endif()
 if(TARGET FFTW3::FFTW3)
   target_link_libraries(votca_tools PRIVATE FFTW3::FFTW3)

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -44,6 +44,12 @@
   set_tests_properties(unit_${PROG} PROPERTIES LABELS "tools;votca;unit")
 
   if(VALGRIND_FOUND)
+    # https://github.com/votca/tools/issues/268
+    # tests seem to trigger a 'Address 0x0 is not stack'd, malloc'd or (recently) free'd' in valgrind
+    set(BROCKEN_MKL_TEST test_crosscorrelate test_cubicspline test_linalg test_linspline)
+    if(MKL_FOUND AND PROG IN_LIST BROCKEN_MKL_TEST)
+      continue()
+    endif()
     add_test(NAME memory_${PROG} COMMAND "${VALGRIND_EXECUTABLE}" --tool=memcheck --leak-check=yes --show-reachable=yes --num-callers=20 --track-fds=yes --error-exitcode=1 $<TARGET_FILE:unit_${PROG}>)
     set_tests_properties(memory_${PROG} PROPERTIES LABELS "tools;votca;memory")
   endif(VALGRIND_FOUND)

=== debian/changelog ===
votca-tools (1.6.4-1) unstable; urgency=medium

  * New upstream release. 

 -- Nicholas Breen <nbreen@debian.org>  Thu, 28 Jan 2021 21:39:24 -0800

votca-tools (1.6.3-1) unstable; urgency=medium

  * New upstream release.
  * Make cross Build-Depends satisfiably annotate python3 with :any.
    Patch courtesy of Helmut Grohne.  (Closes: #973448)
  * Update to Standards-Version 4.5.1, no changes required.

 -- Nicholas Breen <nbreen@debian.org>  Sun, 13 Dec 2020 10:51:39 -0800

=== debian/control ===
--- 
+++ 
@@ -17,10 +17,10 @@
                libfftw3-dev,
                libgsl-dev,
                pkg-config,
-               python3,
+               python3:any,
                txt2tags
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: http://www.votca.org
 Vcs-Browser: https://salsa.debian.org/debichem-team/votca-tools
 Vcs-Git: https://salsa.debian.org/debichem-team/votca-tools.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/votca-tools-$1\.tar\.gz/ \
https://github.com/votca/tools/releases .*/archive/v([\d.]+)\.tar\.(?:bz2|gz)
